/*
 * Blockdaemon REST API
 *
 * Blockdaemon REST API provides a RESTful and uniform way to access blockchain resources, with a rich and reusable model across multiple protocols/cryptocurrencies.  [Documentation](https://docs.blockdaemon.com/reference/rest-api-overview)  ### Currently supported protocols:  * algorand   * mainnet * avalanche    * mainnet-c/testnet-c * bitcoin   * mainnet/testnet * bitcoincash   * mainnet/testnet * dogecoin   * mainnet/testnet * ethereum   * mainnet/holesky/sepolia * fantom   * mainnet/testnet * litecoin   * mainnet/testnet * near   * mainnet * optimism   * mainnet * polkadot   * mainnet/westend * polygon   * mainnet/amoy * solana   * mainnet/testnet * stellar   * mainnet/testnet * tezos   * mainnet * tron   * mainnet/nile * xrp   * mainnet  ### Pagination Certain resources contain a lot of data, more than what's practical to return for a single request. With the help of pagination, the data is split across multiple responses. Each response returns a subset of the items requested, and a continuation token.  To get the next batch of items, copy the returned continuation token to the continuation query parameter and repeat the request with the new URL. In case no continuation token is returned, there is no more data available.
 *
 * API version: 3.0.0
 * Contact: support@blockdaemon.com
 */

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package ubiquity

import (
	"encoding/json"
)

// InlineResponse200 struct for InlineResponse200
type InlineResponse200 struct {
	MostRecentBlock *int32               `json:"most_recent_block,omitempty"`
	EstimatedFees   *FeeEstimateResponse `json:"estimated_fees,omitempty"`
}

// NewInlineResponse200 instantiates a new InlineResponse200 object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewInlineResponse200() *InlineResponse200 {
	this := InlineResponse200{}
	return &this
}

// NewInlineResponse200WithDefaults instantiates a new InlineResponse200 object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewInlineResponse200WithDefaults() *InlineResponse200 {
	this := InlineResponse200{}
	return &this
}

// GetMostRecentBlock returns the MostRecentBlock field value if set, zero value otherwise.
func (o *InlineResponse200) GetMostRecentBlock() int32 {
	if o == nil || o.MostRecentBlock == nil {
		var ret int32
		return ret
	}
	return *o.MostRecentBlock
}

// GetMostRecentBlockOk returns a tuple with the MostRecentBlock field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *InlineResponse200) GetMostRecentBlockOk() (*int32, bool) {
	if o == nil || o.MostRecentBlock == nil {
		return nil, false
	}
	return o.MostRecentBlock, true
}

// HasMostRecentBlock returns a boolean if a field has been set.
func (o *InlineResponse200) HasMostRecentBlock() bool {
	if o != nil && o.MostRecentBlock != nil {
		return true
	}

	return false
}

// SetMostRecentBlock gets a reference to the given int32 and assigns it to the MostRecentBlock field.
func (o *InlineResponse200) SetMostRecentBlock(v int32) {
	o.MostRecentBlock = &v
}

// GetEstimatedFees returns the EstimatedFees field value if set, zero value otherwise.
func (o *InlineResponse200) GetEstimatedFees() FeeEstimateResponse {
	if o == nil || o.EstimatedFees == nil {
		var ret FeeEstimateResponse
		return ret
	}
	return *o.EstimatedFees
}

// GetEstimatedFeesOk returns a tuple with the EstimatedFees field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *InlineResponse200) GetEstimatedFeesOk() (*FeeEstimateResponse, bool) {
	if o == nil || o.EstimatedFees == nil {
		return nil, false
	}
	return o.EstimatedFees, true
}

// HasEstimatedFees returns a boolean if a field has been set.
func (o *InlineResponse200) HasEstimatedFees() bool {
	if o != nil && o.EstimatedFees != nil {
		return true
	}

	return false
}

// SetEstimatedFees gets a reference to the given FeeEstimateResponse and assigns it to the EstimatedFees field.
func (o *InlineResponse200) SetEstimatedFees(v FeeEstimateResponse) {
	o.EstimatedFees = &v
}

func (o InlineResponse200) MarshalJSON() ([]byte, error) {
	toSerialize := map[string]interface{}{}
	if o.MostRecentBlock != nil {
		toSerialize["most_recent_block"] = o.MostRecentBlock
	}
	if o.EstimatedFees != nil {
		toSerialize["estimated_fees"] = o.EstimatedFees
	}
	return json.Marshal(toSerialize)
}

type NullableInlineResponse200 struct {
	value *InlineResponse200
	isSet bool
}

func (v NullableInlineResponse200) Get() *InlineResponse200 {
	return v.value
}

func (v *NullableInlineResponse200) Set(val *InlineResponse200) {
	v.value = val
	v.isSet = true
}

func (v NullableInlineResponse200) IsSet() bool {
	return v.isSet
}

func (v *NullableInlineResponse200) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableInlineResponse200(val *InlineResponse200) *NullableInlineResponse200 {
	return &NullableInlineResponse200{value: val, isSet: true}
}

func (v NullableInlineResponse200) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableInlineResponse200) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
